Ruby - Bug #6490

The 'printf' method in trace_func is not sent to 'stdout’ variable in tracer.rb
05/25/2012 07:17 AM - mfojtik (Michal Foijtik)

Status: Closed

Priority: Normal

Assignee: zzak (zzak _)

Target version: 1.9.3

ruby -v: ruby 1.9.3p194 (2012-04-20 revision Backport:
35410) [x86_64-darwin11.4.0]

Description

Hi,

lib/tracer.rb:189

def trace_func(event, file, line, id, binding, klass, *) # :nodoc:
return if file == FILE

for p in @filters
return unless p.call event, file, line, id, binding, klass
end

return unless Tracer::display_c_call? or
event != "c-call" && event != "c-return"

Tracer::stdout_mutex.synchronize do
if EVENT_SYMBOL [event]
stdout .printf ("<%d>", $$) if Tracer::display_process_id?
stdout.printf ("#%d:", get_thread_no) if Tracer::display_thread_id?

if line == 0
source = "?\n"
else
source = get_line(file, line)
end
printf ("$s:%d:%s:%$s: %s",
file,
line,
klass || ''",
EVENT_SYMBOL [event],
source)
end
end
end

As you see, the last 'printf' method is not sent to 'stdout’ which unfortunately leads to have the output of Tracer print
always to STDOUT.

Associated revisions

Revision b65dda51bd8731a30a94e394¢31198427b90a368 - 11/20/2012 02:05 AM - zzak (zzak _)

e lib/tracer.rb (Tracer.trace_func): printf to stdout
Patch by Michal Fojtik [ruby-core:45219] [Bug #6490]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@37741 b2dd03c8-39d4-4d8f-98ff-823fe69b080e
e lib/tracer.rb (Tracer.trace_func): printf to stdout
Patch by Michal Fojtik [ruby-core:45219] [Bug #6490]
History

#1 - 05/25/2012 07:19 AM - mfojtik (Michal Fojtik)
- File 0001-Bug-6490.patch added

Attaching patch.

#2 - 05/27/2012 01:00 AM - mame (Yusuke Endoh)
- Status changed from Open to Assigned

- Assignee set to keiju (Keiju Ishitsuka)

#3 - 11/19/2012 08:51 AM - zzak (zzak _)

- Assignee changed from keiju (Keiju Ishitsuka) to mame (Yusuke Endoh)

mame, could you look at this?

Keiju-san last connection was over 1 year ago.

#4 - 11/20/2012 03:18 AM - mame (Yusuke Endoh)

- Assignee changed from mame (Yusuke Endoh) to zzak (zzak _)

Looks good to me. Zachary, could you please apply it to trunk?

| guess that Keiju-san does not read English mail (bad!), so | ask him to check your commit in Japanese.

goooooo
Tracer [ stdout.printf 00000000 printt 0000000000000000
(00000000000000O000DOD00DoaD00DaOD00DOD0DDODDDODODODDO

Yusuke Endoh mame@tsg.ne.jp

#5 - 11/20/2012 11:05 AM - zzak (zzak _)
- Status changed from Assigned to Closed

- % Done changed from 0 to 100

This issue was solved with changeset r37741.
Michal, thank you for reporting this issue.

Your contribution to Ruby is greatly appreciated.
May Ruby be with you.

e lib/tracer.rb (Tracer.trace_func): printf to stdout
